using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using OrchardCore.Security.Permissions;

namespace OrchardCore.Sitemaps
{
    public class Permissions : IPermissionProvider
    {
        public static readonly Permission ManageSitemaps = new Permission("ManageSitemaps", "Manage sitemaps");

        public Task<IEnumerable<Permission>> GetPermissionsAsync()
        {
            return Task.FromResult(new[] { ManageSitemaps }.AsEnumerable());
        }

        public IEnumerable<PermissionStereotype> GetDefaultStereotypes()
        {
            return new[]
            {
                new PermissionStereotype
                {
                    Name = "Administrator",
                    Permissions = new[] { ManageSitemaps }
                }
            };
        }
    }
}
