using Microsoft.Extensions.DependencyInjection;
using OrchardCore.Modules;
using OrchardCore.Tenants.Workflows.Activities;
using OrchardCore.Tenants.Workflows.Drivers;
using OrchardCore.Workflows.Helpers;

namespace OrchardCore.Tenants.Workflows
{
    [RequireFeatures("OrchardCore.Workflows")]
    public class Startup : StartupBase
    {
        public override void ConfigureServices(IServiceCollection services)
        {
            services.AddActivity<DisableTenantTask, DisableTenantTaskDisplay>();
            services.AddActivity<EnableTenantTask, EnableTenantTaskDisplay>();
            services.AddActivity<CreateTenantTask, CreateTenantTaskDisplay>();
            services.AddActivity<SetupTenantTask, SetupTenantTaskDisplay>();
        }
    }
}
