# Guides

Whatever you're building, these guides are designed to get you productive as quickly as possible using the latest Orchard Core project releases and techniques as recommended by the Orchard team.

## Getting Started Guides

Designed to be completed in 15-30 minutes, these guides provide quick, hands-on instructions for building the "Hello World" of any development task with Orchard Core. In most cases, the only prerequisites are a .NET SDK and a text editor.

- [Creating a Modular ASP.NET Core Application](create-modular-application-mvc/README.md)
- [Running Code on Startup](run-code-on-startup/README.md)
- [Customizing encoding settings](encoding-settings/README.md)

### Orchard Core CMS Guides

These guides are specific to Orchard Core CMS

- [Creating an Orchard Core CMS website](create-cms-application/README.md)
- [Adding a Menu Item to the Admin Navigation](add-admin-menu/README.md)
- [Installing Localization Files](install-localization-files/README.md)
- [Integrate facebook plugins](integrate-facebook-plugins/README.md)
- [Implement Full Text search](implement-fulltext-search/README.md)

## Tutorials

Designed to be completed in 2-3 hours, these guides provide deeper, in-context explorations of enterprise application development topics, leaving you ready to implement real-world solutions.

- [Building a decoupled website with Razor Pages](decoupled-cms/README.md)
- Building a Website from a Web Template (TBD)
- Implementing a Self-Service SaaS solution (TBD)
